# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b95"
os.chdir("/Users/wstein/.sage/sage_notebook/worksheets/admin/133/cells/49")
sage.server.notebook.interact.SAGE_CELL_ID=49
_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_8 = Integer(8)
__tmp__=var("mu,sigma,x"); normal = symbolic_expression(_sage_const_1 /(sigma*sqrt(_sage_const_2 *pi)) * exp(-(x-mu)**_sage_const_2 /(_sage_const_2 *sigma**_sage_const_2 ))).function(mu,sigma,x)
def kstest(data, mu, sigma):
    """Returns D value and p value.  Data is more likely to be normal if p is BIG, e.g., p > 0.05"""
    import scipy.stats
    N = scipy.stats.distributions.norm(float(mu),float(sigma)).cdf
    def dist(x):
        return [N(y) for y in x]
    D, p = scipy.stats.kstest(data, dist)
    return D, float(p)

@interact
def f(ticker='JAVA', start=['Jan+1,+1990', 'Jan+1,+2000', 'Jan+1,+2007',  'Jan+1,+2008', 'Jan+1,+2009']):
    print "Closing price of %s since %s (if the stock goes back that far)"%(ticker.upper(),start)
    try:
       S = finance.Stock(ticker)
       T = S.close(startdate=start)
    except RuntimeError:
        print "unable to get data about %s"%ticker
        return

    R = T.log().diffs()
    mu = R.mean()
    sigma = R.standard_deviation()
    print "Mean =", mu
    print "Standard deviation = ", sigma
    G = R.plot_histogram() + plot(normal(mu, sigma), (x,min(R),max(R)),rgbcolor='black', thickness=_sage_const_3 )
    print "KS test = ", kstest(R, mu, sigma)
    show(graphics_array([T.plot(), G], _sage_const_1 ,_sage_const_2 ), figsize=[_sage_const_8 ,_sage_const_3 ])

print "e95"
